unit uDolls;

interface

uses
  uToy
  ;

type

  TDolls = class(TToy)
  private

    FSetNo: integer;
    FPlayDesc: string;

  protected

    function GetName: string; override;
    procedure SetSetNo(Value: integer); override;

  public

    procedure PlayWithMe; override;
    procedure TidyMeAway; override;

    property Name: string
      read GetName;

    property SetNo: integer
      write SetSetNo;

  published

  end;


implementation

uses
  sysutils
  , dialogs
  ;

{ TDolls }

function TDolls.GetName: string;
begin
  Result := 'No. ' + IntToStr(FSetNo) + ' set of dolls';
end;

procedure TDolls.PlayWithMe;
begin
  ShowMessage('Hi! I''m ' + FPlayDesc + ' and I want to be your friend.');
end;

procedure TDolls.SetSetNo(Value: integer);
begin
  case Value of
    1: FPlayDesc := 'Jade';
    2: FPlayDesc := 'Joe';
    3: FPlayDesc := 'Bill Gates';
  end;
  FSetNo := Value;
end;

procedure TDolls.TidyMeAway;
begin
  ShowMessage('Well done. You''ve put away dolls set ' + IntToStr(FSetNo));
end;

end.
